diff --git a/example/generator/odp_generator.c b/example/generator/odp_generator.c
index 6055324..5538d0c 100644
--- a/example/generator/odp_generator.c
+++ b/example/generator/odp_generator.c
@@ -397,7 +397,7 @@ static void print_pkts(int thr, odp_packet_t pkt_tbl[], unsigned len)
 
 		odp_atomic_inc_u64(&counters.ip);
 		rlen += sprintf(msg, "receive Packet proto:IP ");
-		buf = odp_buffer_addr(odp_buffer_from_packet(pkt));
+		buf = odp_buffer_addr(odp_packet_to_buffer(pkt));
 		ip = (odph_ipv4hdr_t *)(buf + odp_packet_l3_offset(pkt));
 		rlen += sprintf(msg + rlen, "id %d ",
 				odp_be_to_cpu_16(ip->id));
diff --git a/example/ipsec/odp_ipsec.c b/example/ipsec/odp_ipsec.c
index ec6c87a..56539ba 100644
--- a/example/ipsec/odp_ipsec.c
+++ b/example/ipsec/odp_ipsec.c
@@ -738,7 +738,7 @@ pkt_disposition_e do_ipsec_in_classify(odp_packet_t pkt,
 	*skip = FALSE;
 	if (odp_crypto_operation(&params,
 				 &posted,
-				 odp_buffer_from_packet(pkt))) {
+				 odp_packet_to_buffer(pkt))) {
 		abort();
 	}
 	return (posted) ? PKT_POSTED : PKT_CONTINUE;
@@ -764,7 +764,7 @@ pkt_disposition_e do_ipsec_in_finish(odp_packet_t pkt,
 	int trl_len = 0;
 
 	/* Check crypto result */
-	event = odp_buffer_from_packet(pkt);
+	event = odp_packet_to_buffer(pkt);
 	odp_crypto_get_operation_compl_status(event, &cipher_rc, &auth_rc);
 	if (!is_crypto_compl_status_ok(&cipher_rc))
 		return PKT_DROP;
@@ -935,7 +935,7 @@ pkt_disposition_e do_ipsec_out_classify(odp_packet_t pkt,
 
 	/* Send packet to the atmoic queue to assign sequence numbers */
 	*skip = FALSE;
-	odp_queue_enq(seqnumq, odp_buffer_from_packet(pkt));
+	odp_queue_enq(seqnumq, odp_packet_to_buffer(pkt));
 
 	return PKT_POSTED;
 }
@@ -974,7 +974,7 @@ pkt_disposition_e do_ipsec_out_seq(odp_packet_t pkt,
 	/* Issue crypto request */
 	if (odp_crypto_operation(&ctx->ipsec.params,
 				 &posted,
-				 odp_buffer_from_packet(pkt))) {
+				 odp_packet_to_buffer(pkt))) {
 		abort();
 	}
 	return (posted) ? PKT_POSTED : PKT_CONTINUE;
@@ -998,7 +998,7 @@ pkt_disposition_e do_ipsec_out_finish(odp_packet_t pkt,
 	odph_ipv4hdr_t *ip;
 
 	/* Check crypto result */
-	event = odp_buffer_from_packet(pkt);
+	event = odp_packet_to_buffer(pkt);
 	odp_crypto_get_operation_compl_status(event, &cipher_rc, &auth_rc);
 	if (!is_crypto_compl_status_ok(&cipher_rc))
 		return PKT_DROP;
diff --git a/helper/include/odph_packet.h b/helper/include/odph_packet.h
index c18f48d..3d53593 100644
--- a/helper/include/odph_packet.h
+++ b/helper/include/odph_packet.h
@@ -31,7 +31,7 @@ extern "C" {
  */
 static inline int odph_packet_is_valid(odp_packet_t pkt)
 {
-	odp_buffer_t buf = odp_buffer_from_packet(pkt);
+	odp_buffer_t buf = odp_packet_to_buffer(pkt);
 
 	return odp_buffer_is_valid(buf);
 }
@@ -67,7 +67,7 @@ static inline odp_packet_t odph_packet_alloc(odp_buffer_pool_t pool_id)
  */
 static inline void odph_packet_free(odp_packet_t pkt)
 {
-	odp_buffer_t buf = odp_buffer_from_packet(pkt);
+	odp_buffer_t buf = odp_packet_to_buffer(pkt);
 
 	odp_buffer_free(buf);
 }
@@ -84,7 +84,7 @@ static inline void odph_packet_free(odp_packet_t pkt)
  */
 static inline size_t odph_packet_buf_size(odp_packet_t pkt)
 {
-	odp_buffer_t buf = odp_buffer_from_packet(pkt);
+	odp_buffer_t buf = odp_packet_to_buffer(pkt);
 
 	return odp_buffer_size(buf);
 }
diff --git a/platform/linux-generic/include/api/odp_packet.h b/platform/linux-generic/include/api/odp_packet.h
index 316279b..8204000 100644
--- a/platform/linux-generic/include/api/odp_packet.h
+++ b/platform/linux-generic/include/api/odp_packet.h
@@ -63,7 +63,7 @@ typedef struct odp_packet_seg_info_t {
 void odp_packet_init(odp_packet_t pkt);
 
 /**
- * Convert from packet handle to buffer handle
+ * Convert a buffer handle to a packet handle
  *
  * @param buf  Buffer handle
  *
@@ -72,13 +72,13 @@ void odp_packet_init(odp_packet_t pkt);
 odp_packet_t odp_packet_from_buffer(odp_buffer_t buf);
 
 /**
- * Convert from buffer handle to packet handle
+ * Convert a packet handle to a buffer handle
  *
  * @param pkt  Packet handle
  *
  * @return Buffer handle
  */
-odp_buffer_t odp_buffer_from_packet(odp_packet_t pkt);
+odp_buffer_t odp_packet_to_buffer(odp_packet_t pkt);
 
 /**
  * Set the packet length
diff --git a/platform/linux-generic/odp_crypto.c b/platform/linux-generic/odp_crypto.c
index b37ad6b..1475437 100644
--- a/platform/linux-generic/odp_crypto.c
+++ b/platform/linux-generic/odp_crypto.c
@@ -367,9 +367,9 @@ odp_crypto_operation(odp_crypto_op_params_t *params,
 		if (odp_unlikely(ODP_PACKET_INVALID == params->out_pkt))
 			abort();
 		odp_packet_copy(params->out_pkt, params->pkt);
-		if (completion_event == odp_buffer_from_packet(params->pkt))
+		if (completion_event == odp_packet_to_buffer(params->pkt))
 			completion_event =
-				odp_buffer_from_packet(params->out_pkt);
+				odp_packet_to_buffer(params->out_pkt);
 		odph_packet_free(params->pkt);
 		params->pkt = ODP_PACKET_INVALID;
 	}
diff --git a/platform/linux-generic/odp_packet.c b/platform/linux-generic/odp_packet.c
index 435bc8b..82ea879 100644
--- a/platform/linux-generic/odp_packet.c
+++ b/platform/linux-generic/odp_packet.c
@@ -41,7 +41,7 @@ odp_packet_t odp_packet_from_buffer(odp_buffer_t buf)
 	return (odp_packet_t)buf;
 }
 
-odp_buffer_t odp_buffer_from_packet(odp_packet_t pkt)
+odp_buffer_t odp_packet_to_buffer(odp_packet_t pkt)
 {
 	return (odp_buffer_t)pkt;
 }
@@ -58,7 +58,7 @@ size_t odp_packet_get_len(odp_packet_t pkt)
 
 uint8_t *odp_packet_addr(odp_packet_t pkt)
 {
-	return odp_buffer_addr(odp_buffer_from_packet(pkt));
+	return odp_buffer_addr(odp_packet_to_buffer(pkt));
 }
 
 uint8_t *odp_packet_data(odp_packet_t pkt)
@@ -381,8 +381,8 @@ int odp_packet_copy(odp_packet_t pkt_dst, odp_packet_t pkt_src)
 	pkt_hdr_dst->buf_hdr.cur_offset = pkt_hdr_src->buf_hdr.cur_offset;
 
 	/* Create a copy of the scatter list */
-	odp_buffer_copy_scatter(odp_buffer_from_packet(pkt_dst),
-				odp_buffer_from_packet(pkt_src));
+	odp_buffer_copy_scatter(odp_packet_to_buffer(pkt_dst),
+				odp_packet_to_buffer(pkt_src));
 
 	return 0;
 }
diff --git a/platform/linux-generic/odp_packet_io.c b/platform/linux-generic/odp_packet_io.c
index 0c30f0f..d6f86ce 100644
--- a/platform/linux-generic/odp_packet_io.c
+++ b/platform/linux-generic/odp_packet_io.c
@@ -431,11 +431,11 @@ odp_buffer_hdr_t *pktin_dequeue(queue_entry_t *qentry)
 
 		if (pkts > 0) {
 			pkt = pkt_tbl[0];
-			buf = odp_buffer_from_packet(pkt);
+			buf = odp_packet_to_buffer(pkt);
 			buf_hdr = odp_buf_to_hdr(buf);
 
 			for (i = 1, j = 0; i < pkts; ++i) {
-				buf = odp_buffer_from_packet(pkt_tbl[i]);
+				buf = odp_packet_to_buffer(pkt_tbl[i]);
 				tmp_hdr_tbl[j++] = odp_buf_to_hdr(buf);
 			}
 			queue_enq_multi(qentry, tmp_hdr_tbl, j);
@@ -467,7 +467,7 @@ int pktin_deq_multi(queue_entry_t *qentry, odp_buffer_hdr_t *buf_hdr[], int num)
 				      QUEUE_MULTI_MAX);
 		if (pkts > 0) {
 			for (i = 0; i < pkts; ++i) {
-				buf = odp_buffer_from_packet(pkt_tbl[i]);
+				buf = odp_packet_to_buffer(pkt_tbl[i]);
 				tmp_hdr_tbl[i] = odp_buf_to_hdr(buf);
 			}
 			queue_enq_multi(qentry, tmp_hdr_tbl, pkts);